


---

 25-akpm/mm/mempolicy.c |    4 ++--
 1 files changed, 2 insertions(+), 2 deletions(-)

diff -puN mm/mempolicy.c~numa-api-core-i_shared_sem mm/mempolicy.c
--- 25/mm/mempolicy.c~numa-api-core-i_shared_sem	Tue Apr 20 17:39:49 2004
+++ 25-akpm/mm/mempolicy.c	Tue Apr 20 17:40:06 2004
@@ -296,7 +296,7 @@ static int policy_vma(struct vm_area_str
 		 vma->vm_ops ? vma->vm_ops->set_policy : NULL);
 
 	if (vma->vm_file)
-		down(&vma->vm_file->f_mapping->i_shared_sem);
+		spin_lock(&vma->vm_file->f_mapping->i_shared_lock);
 	if (vma->vm_ops && vma->vm_ops->set_policy)
 		err = vma->vm_ops->set_policy(vma, new);
 	if (!err) {
@@ -305,7 +305,7 @@ static int policy_vma(struct vm_area_str
 		mpol_free(old);
 	}
 	if (vma->vm_file)
-		up(&vma->vm_file->f_mapping->i_shared_sem);
+		spin_unlock(&vma->vm_file->f_mapping->i_shared_lock);
 	return err;
 }
 

_
